============                                        First writing: 2005-02-16
esl overview
============

1. Interactive use of esl.
Type esl input in the empty line after the line with the input prompt (>>).
End your input with a semicolon, then hit the return key. The output will be
displayed on the next line after ==>.
Processing of statements (called "evaluation") in esl does not start unless
you type in the semicolon. The semicolon separates evaluation units.
In new esl versions (starting with version 0.06) you can alternatively 
omit the semicolon and hit the return key twice (see procedure returnreturnon
in the help text "functions").

2. The delimiting character within structures (control structures, function
calls, ...) is always the comma. The comma delimits arguments and
statements. You may enter several statements, delimited by commas, before you
enter a semicolon and [return key] to start evaluation.

3. esl is (contrary to most scheme systems) case sensitive. The current
guile versions are, however, case sensitive.

4. Input may consist of several lines. The newline character only means
"white space" (the same as e.g. a space character).

5. Procedure calls with exactly one simple argument may be written without
parentheses:

sin x

is equaivalent to

sin(x)


6. When esl crashes, you will usually be thrown back to the scheme prompt.

Typing

scheme();

in esl will bring you to scheme. The scheme procedure call

(esl)

will bring you back to esl. The esl variables keep their values.

7. There is no real distinction between statemants and expressions in esl.
Every esl expression returns a (possibly useless) value.

8. There is garbage collection in esl. You do not have to deal with freeing
memory.

9. Hint: Look at the esl code contained in the files /usr/local/esl/*.e

10. You can "load" esl code from a text file. The esl code is read and
processed as if it was typed in interactively. For details see procedure
"load" in the help text "functions".

11. Some terminology
Some confusion might arise from the fact that language construct terms may
refer to syntax or to semantics. 
    - The term "function" is used here in a syntactical sense. Functions
      may always be invoked in the form 
      f(arg1, arg2, ...)
      This applies for zero-argument functions as well:
      g()
      is a syntactically correct function invocation.
    - The term "procedure" refers to semantics. esl procedures correspond
      to scheme procedures. Processing a procedure invocation means evaluating
      the expression in the procedure position and all arguments.
      In many cases functions (syntax) correspond to procedures. However,
      push(el,lis)
      is an example of a function invocation which is not a procedure
      invocation. push does not substitute the symbol lis by the value
      of lis before passing el und lis to push (in a sense, lis is an 
      input- and output argument).
    - The term "operator" refers to syntax. There are prefix, infix and
      postfix operators. Semantically, some operators act like procedures (the
      (arithmetic operators +, -, *, /, the comparison operators <, <=, =),
      others do not (::, :=, and, or, ...).
    - The term "control construct" refers to syntax. Control constructs are
      specified by special words (if, then, endif, for, ... endfor).
    - The term "macro" with respect to esl is not used in a strict sense. In
      any case, it is not applied to procedures (i.e. functions or operators
      with standard evaluation of arguments or operands, respectively.)
    - Language constructs may have effects on the environment (values of
      of symbols), or they may produce output or depend on input. This
      introduces yet another classification of languages constructs.
