plotwords_version::"0.02",plotwords_date::"16.04.2000";

*** Colors ***

red         :: {1,0,0};
lightgreen  :: {0,1,0};
darkgreen   :: {0,0.6,0};
green       :: {0,0.8,0};
brown       :: {0.6,0.4,0};
blue        :: {0,0,1};
darkmagenta :: {0.6,0,0.6};
darkcyan    :: {0,0.6,0.6};
magenta     :: {1,0,1};
cyan        :: {0,1,1};
yellow      :: {1,1,0};
black       :: {0,0,0};

*** Drawing Types ***

square      :: 'sq;
circle      :: 'circ;
triangle    :: 'tri;
fill        :: 'fill;
closed      :: 'clos;
simple      :: 'line;
impulses    :: 'imp;

*** Procedures for plot object definitions ***

po(f,+r)    :: append({f},r);
object      :: po;

*** Procedures and other symbols for attributes and extras definitions ***

legend(l)      :: {'leg,l};

color(r,+gb)   :: if length(gb) == 2 then
                    append({'rg,r},gb)
                  else
                    cons('rg,r)
                  endif;

dash(a,+b)     :: append({'da,a},b);
dashing        :: dash;
offset         :: 'o;
width(w)       :: {'wi,w};
size(s)        :: {'si,s};
font(f,s)      :: {'fo,f,s};

text(s,x,y,+ang) 
               :: append({'te,s,x,y},ang);

type(t)        :: {'dr,t};
domain(f,t,+s) :: append({'ra,f,t},s);

line(x1,y1,+r) :: append({'li,x1,y1},r);

bars(w,bs,m)   :: {'bars,w,bs,m};

postscript(p1,+p2)
               :: append({'ps,p1},p2);

*** Procedures and symbols for plot range definitions ***

title(s)       :: {'title,s};
noxcoords      :: 'noxcoords;
noycoords      :: 'noycoords;
nocoords       :: 'nocoords;
default        :: 'default;
a4w            :: 'a4w;
auto           :: 'auto;

*** More ***

scale(r)::{'scale,r};

displayln("--- esl file \"plotwords\" (Version ",plotwords_version,", ",
                                                   plotwords_date,")");
