symfuns_version::"0.3",symfuns_date::"07.03.2000";

st2sy::string2symbol;
sy2st::symbol2string;
plussymbol     :: st2sy("+");
minussymbol    :: st2sy("-");
asterisksymbol :: st2sy("*");
slashsymbol    :: st2sy("/");
powersymbol    :: st2sy("expt");
logsymbol      :: st2sy("log2"); 

makeplus(s1,+s) :: if nullq(s) then 
                     {plussymbol,s1}
                   else
                     append({plussymbol,s1},s)
                   endif;

makeminus(s1,+s) :: if nullq(s) then 
                      {minussymbol,s1}
                    else
                      append({minussymbol,s1},s)
                    endif;

makeasterisk(s1,s2) :: {asterisksymbol,s1,s2};

makeslash(s1,s2)    :: {slashsymbol,s1,s2};

makepower(s1,s2)    :: {powersymbol,s1,s2};

makelog(s1,s2)      :: {logsymbol,s1,s2};

makeex1(f,s)        :: {f,s};
makeex2(f,s1,s2)    :: {f,s1,s2};

is_in(var,ex) ::
  listq(ex) and not nullq(ex) and 
                            (is_in(var,first(ex)) or is_in(var,rest(ex)))
  or
  symbolq(ex) and var === ex;


dflist(var,l) :: if nullq(l) then 
                    {} 
                  else 
                    cons(simplify(df(var,first(l))),dflist(var,rest(l)))
                  endif;

df(var,ex)::  if listq(ex) then
                with 
                  symb :: first(ex),
                  sfex :: sy2st(symb) 
                do
                  if length(ex) > 3 then
                    if symb === plussymbol or symb === minussymbol then
                      cons(symb,dflist(var,rest(ex))) 
                    else 
                      df(var,{symb,second(ex),cons(symb,restofrest(ex))})
                    endif
                  elseif length(ex) == 2 and symb === plussymbol then
                     df(var,second(ex))
                  elseif length(ex) == 2 and symb === minussymbol then
                     makeminus(df(var,second(ex)))
                  elseif length(ex) == 2 and symb === 'sin then
                     makeasterisk(makeex1('cos,second(ex)),df(var,second(ex)))
                  elseif length(ex) == 2 and symb === 'cos then
                     makeminus(  
                       makeasterisk(
                         makeex1('sin,second(ex)),
                         df(var,second(ex))
                       )
                     )
                  elseif length(ex) == 2 and symb === 'exp then
                     makeasterisk(ex,df(var,second(ex)))
                  elseif length(ex) == 2 and symb === 'sqrt then
                     df(var,makepower(second(ex),1/2))
                  elseif length(ex) == 2 and symb === 'tan then
                     makeslash(
                       df(var,second(ex)),
                       makepower(makeex1('cos,second(ex)),2)
                     )
                  elseif length(ex) == 2 and symb === 'ln then
                    makeasterisk(df(var,second(ex)),makepower(second(ex),-1))
                  elseif length(ex) == 2 and symb === 'atan then
                    makeasterisk(
                      df(var,second(ex)),
                      makepower(
                        makeplus(1,makepower(second(ex),2)),
                        -1
                      )  
                    )
                  elseif symb === plussymbol then
                     makeplus(df(var,second(ex)),df(var,third(ex)))
                  elseif symb === minussymbol then
                     makeminus(df(var,second(ex)),df(var,third(ex)))
                  elseif symb === asterisksymbol then
                     makeplus(
                       makeasterisk(df(var,second(ex)),third(ex)),
                       makeasterisk(second(ex),df(var,third(ex)))
                     )
                  elseif symb === slashsymbol then
                     makeslash(
                        makeminus(
                           makeasterisk(df(var,second(ex)),third(ex)),
                           makeasterisk(df(var,third(ex)),second(ex))
                        ), 
                        makepower(third(ex),2)
                     )
                  elseif symb === 'log and not is_in(var,second(ex)) then
                     makeslash(
                        df(var,third(ex)),
                        makeasterisk(
                          makeex1('ln,second(ex)),
                          third(ex)
                        )
                     )
                  elseif symb === powersymbol and not is_in(var,third(ex)) then
                    makeasterisk(
                      third(ex),
                      makeasterisk(
                        makepower(second(ex),makeminus(third(ex),1)),
                        df(var,second(ex))
                      )
                    )
                  elseif symb === powersymbol then
                    if is_in(var,second(ex)) then
                      df(
                        var,
                        makeex1(
                          'exp,
                          makeasterisk(third(ex),makeex1('ln,second(ex)))
                        )
                      )
                    else
                      makeasterisk(
                        df(var,third(ex)),
                        makeasterisk(makeex1('ln,second(ex)),ex)
                      )
                    endif
                  else displayln("Derivative of the expression ",ex,
                                      " is not implemented yet."),
                    0
                  endif
                endwith
              elseif numberq(ex) then
                0
              elseif symbolq(ex) and var === ex then
                1
              elseif symbolq(ex) and not var === ex then
                0
              else
                displayln("derivative: Derivative of ",ex,
                                                 " cannot be found."), 
                0
              endif;

depth(s) :: if listq(s) then
              if nullq(s) then
                0
              else
                max(1+depth(first(s)),depth(rest(s)))
              endif
            else
              0
            endif;

term_less_than(a,b) ::
     a == 0
  or a == 0.0
  or integerq(a) and not b == 0 and not b == 0.0
  or numberq(a) and not integerq(b)
  or symbolq(a) and listq(b)
  or listq(a) and listq(b) and depth(a) < depth(b)
  or symbolq(a) and symbolq(b) and stringltq(sy2st(a),sy2st(b));

scount :: 0;

simplifylist(l) ::
if nullq(l) or not listq(l) then
  l
else
  cons(simplify(first(l)),simplifylist(rest(l)))
endif;  

removeprefixminus(ex) ::
if not listq(ex) or nullq(ex) then
  ex
elseif length(ex) = 2 and first(ex) === minussymbol then
  makeasterisk(-1,removeprefixminus(second(ex)))
else
  cons(removeprefixminus(first(ex)),removeprefixminus(rest(ex)))
endif;

flatten(ex) ::
with
  h::#f
do
***  displayln("in flatten - ex is : ",ex),
  if not listq(ex) or length(ex) <= 1 then
    ex
  elseif first(ex) in {plussymbol, asterisksymbol} then
    cons(first(ex),flattenop(first(ex),map(flatten,rest(ex)) ))
  else
    cons(first(ex),map(flatten,rest(ex)))
  endif
endwith;

flattenop(op,l) ::
begin
***  displayln("in flattenop - op, l : ",op," | ",l),
  if nullq(l) then
    l
  elseif listq(first(l)) and not nullq(first(l)) and first(first(l)) === op
                                                                         then
    append(rest(first(l)),flattenop(op,rest(l)))
  else
    cons(first(l),flattenop(op,rest(l)))
  endif
end;   

topowers(ex)::
begin ***display("entering 2powers|"),
if length(ex) <= 1 then
  ex
elseif first(ex)=second(ex) then
  cons(makepower(first(ex),2),topowers(restofrest(ex)))
elseif listq(first(ex)) and not nullq(first(ex)) 
               and first(first(ex)) === powersymbol
               and second(first(ex)) = second(ex) then
  cons(makepower(second(ex),makeplus(1,third(first(ex)))),
                                        topowers(restofrest(ex)))
elseif listq(second(ex)) and not nullq(second(ex)) 
               and first(second(ex)) === powersymbol
               and second(second(ex)) = first(ex) then
  cons(makepower(first(ex),makeplus(1,third(second(ex)))),
                  topowers(restofrest(ex)))
else
  cons(first(ex),topowers(rest(ex)))
endif
end;

simplify(ex)::
with
  len :: if listq(ex) then length(ex) else 0 endif,
  op  :: if listq(ex) then first(ex) else {} endif,
  a   :: if listq(ex) then simplify(second(ex)) else {} endif,
  b   :: if listq(ex) and len > 2 then 
             simplify(third(ex)) 
           else 
             {} 
           endif,
  h  :: #f,
  hh :: 'undefined
do
***  displayln(":ex is: ",ex, ":len is: ",len),
***  display("simplified:",simplify(ex)),
***  displayln("enter simplify, scount*",++scount," ex: ",ex," len ",len),
  if not listq(ex) then
    ex
  elseif len > 3 then
    h := cons(first(ex),simplifylist(rest(ex))),
    h := quicksort(rest(h),term_less_than),
    if first(ex) === asterisksymbol then
***      display("h b4 2pow is ",h),
      h := topowers(h)
***      displayln("h after 2pow is ",h)
    endif,
***    displayln(" h after is ",h),
***    display("to simplify: "),displayln({op,first(h),cons(op,rest(h))}),
    if length(h) > 2 then
      hh:=simplify({op,first(h),simplify(cons(op,rest(h)))})
    else
      hh:=simplify(cons(op,h))
    endif,
***    displayln("simplified: ",hh),
    hh
  elseif op === plussymbol then
    if not b = {} and term_less_than(b,a) then h := a, a := b, b := h endif,
***    displayln("op===plus, a,b : ",a," ",b),
    if a == 0 then
      b
    elseif b = {} then
      a
    elseif b == 0 then
      a
    elseif numberq(a) and numberq(b) then
      a + b
    elseif numberq(a) and listq(b) and first(b) = op and numberq(second(b)) 
                                                                         then
      {op,a+second(b),third(b)}
    elseif a = b then
      makeasterisk(2,a)
    elseif listq(b) and length(b) == 2 and first(b) === minussymbol 
      and a = second(b) then
      0
    elseif listq(a) and not nullq(a) and listq(b) and not nullq(b) and
      first(a) === asterisksymbol and first(a)===first(b) 
      and second(a) = second(b) and length(a)==3 and length(b)==3 then
      makeasterisk(second(a),simplify(makeplus(third(a),third(b))))
    elseif listq(b) and length(b) == 2 and first(b) === minussymbol then
      makeminus(a,second(b))
    else
      {op,a,b}
    endif
  elseif op === minussymbol then
    if a = 0 and not b = {} then
      if numberq(b) then -b else {op,b} endif
    elseif b = {} then
      if numberq(a) then
        -a
      elseif listq(a) and length(a) == 2 and first(a) === minussymbol then
        second(a)
      else
        {op,a}
      endif
    elseif b = 0 then
      a
    elseif numberq(a) and numberq(b) then
      a - b
    else
      if listq(b) and first(b) === asterisksymbol and numberq(second(b)) then
        makeplus(a,append({asterisksymbol,-second(b)},restofrest(b)))
      elseif listq(b) and first(b) === asterisksymbol then
        makeplus(a,append({asterisksymbol,-1},rest(b)))
      else
        {op,a,b}
      endif
    endif
  elseif op === asterisksymbol then
    if term_less_than(b,a) then h:=a, a:=b, b:=h endif,
***    displayln("op=== *, a,b : ",a," ",b),
    if a = 1 then
      b
    elseif b = 1 then
      a
    elseif a = 0 or b = 0 then
      0
    elseif numberq(a) and numberq(b) then
      a*b
    elseif numberq(a) and listq(b) and not nullq(b) and first(b) = op 
                                                 and numberq(second(b)) then
      append({op,a*second(b)},restofrest(b))
    elseif listq(b) and first(b) === slashsymbol and second(b) = 1 
                                                       and a = third(b) then
      1
    elseif listq(a) and not nullq(a) and listq(b) and 
            not nullq(b) and first(a) === op and first(b) === op then
      cons(op,append(rest(a),rest(b)))
    elseif listq(b) and not nullq(b) and first(b) === op then
      cons(op,cons(a,rest(b)))
    elseif a = b then
      makepower(a,2)
    elseif listq(a) and not nullq(a) and listq(b) and not nullq(b) and
      first(a) === powersymbol and first(a)===first(b) 
      and second(a) = second(b) then
      makepower(second(a),simplify(makeplus(third(a),third(b))))
    elseif listq(b) and not nullq(b) and first(b) === powersymbol 
                                              and a = second(b) then
      makepower(a,simplify(makeplus(1,third(b))))
    elseif a==-1 or a == -1.0 and not nullq(b) then
      makeminus(b)
    elseif listq(b) and length(b) == 2 and first(b)===minussymbol 
                                                     and second(b) = a then
      makeminus(makepower(a,2))
    else
      {op,a,b}
    endif
  elseif op === slashsymbol then
    if a = b and not a = 0 then
      1
    elseif a == 0 and not b == 0 then
      0
    elseif numberq(a) and numberq(b) and not b==0 then
      a/b
    elseif b == 1 then
      a
    elseif b == -1 then
      makeasterisk(-1,a)
    elseif listq(a) and first(a) === asterisksymbol and numberq(second(a))
      and numberq(b) and not b = 0 then
      append({asterisksymbol,second(a)/b},restofrest(a))
    elseif listq(a) and first(a) === asterisksymbol and numberq(second(a))
      and listq(b) and first(b) === asterisksymbol and numberq(second(b))
                                             and not second(b) = 0 then
      {op,
        append({asterisksymbol,second(a)/second(b)},restofrest(a)),
        if length(b) == 3 then 
          third(b) 
        else 
          cons(asterisksymbol,restofrest(b))
        endif
      }
    else
      {op,a,b}
    endif
  elseif op === powersymbol then
    if b == 1 then
      a
    elseif b == 0 then
      1
    elseif numberq(a) and numberq(b) then
      a ^ b
    elseif a == 0 and numberq(b) and b > 0 then
      0
    elseif numberq(b) and listq(a) and first(a) === powersymbol 
                                     and numberq(third(a)) then
      {op,second(a),b*third(a)}
    elseif listq(a) and length(a) = 2 and first(a) === minussymbol and
                                                              b = 2 then
      makepower(second(a),2)
    else
      {op,a,b}
    endif
  elseif op === 'ln and len == 2 and a == 'e then
    1
  else
    if len == 2 then
      {op,a}
    else
      {op,a,b}
    endif
  endif
endwith;

symfunq(sf) ::
      listq(sf) 
      and length(sf) == 3
      and first(sf)  ===  st2sy("lambda")
      and listq(second(sf))
      and length(second(sf)) == 1
      and symbolq(first(second(sf)));

simplifysymfun(sf)::
if symfunq(sf) then
  {first(sf),second(sf),simplify(third(sf))}
else
  displayln("simplifysymfun: ",sf," is not a symbolic function."),
  sf
endif;

D(sf) ::
if not symfunq(sf) then
  displayln("derivative: Invalid argument: ",sf),
  {}
else
  {st2sy("lambda"),
   second(sf),
   simplify(simplify(flatten(simplify(flatten(removeprefixminus(df
                                      (first(second(sf)),third(sf))))))))}
endif;

Dn(sf,n) :: if not integerq(n) or n < 0 or not symfunq(sf) then
              displayln("Dn (n-th derivative): invalid argument(s): ",
                                                           sf," ",n)
            elseif n == 0 then
              sf
            else 
              Dn(D(sf),n-1)
            endif;

taylorcoef(sf,x0,n) :: 
  if not integerq(n) or n < 0 or not symfunq(sf) or not numberq(x0)  then
    displayln("taylor : invalid argument(s) (sf, x0, n) : ",sf," ",x0," ",n),
    {}
  else
    with l :: {(&sf)(x0),x0},
         f :: sf,
         fac :: 1
    do
      if n > 0 then
        for i from 1 to n do push((fac:fac/i)*(&(f:D f))(x0),l) endfor
      endif,
      reverse(l)
    endwith 
  endif;

taylorfun(sf,x0,n) ::
  with l :: taylorcoef(sf,x0,n) do
  if n == 0 then
    x -> listref(l,1)
  else
    if x0 == 0 then
      x -> listref(l,1) + sum i-> x^i*listref(l,i+1) from 1 to n endsum
    else
      x -> listref(l,1) + sum  i-> (x-x0)^i*listref(l,i+1) from 1 to n endsum
    endif
  endif
endwith; 

snewton(sf,x,eps,nmax) :: newton(&sf,&D(sf),x,eps,nmax);
   *** This will only work if "misc_num.e" is loaded or "newton" is defined
   *** otherwise in a correct way.

tangent(f,x,l)::
if not (symfunq(f) and numberq(x) and numberq(l) and l > 0) then
  displayln("tangent: invalid arguments: ",f," ",x," ",l)
else
  with
    y     :: (&f)(x),
    ang   :: atan( (&(D(f))) (x)),
    dy    :: (l/2)*sin(ang),
    dx    :: (l/2)*cos(ang) 
  do
    {'li,x-dx,y-dy,x+dx,y+dy}
  endwith
endif;

displayln("--- esl file \"symfuns\" (Version ",symfuns_version,", ",
                                                        symfuns_date,")");
