begin
display("This is the module \"test_linear_algebra\".\n",
   "Version and date of this test module:"), 
  test_linear_algebra_version::"0.03", 
  test_linear_algebra_date::"06.02.2005",
  displayln(test_linear_algebra_version,"  ",test_linear_algebra_date)
end;
displayln("\nScheme system is ",$scheme_system);
displayln("\n*** Testing procedures in module \"linear_algebra\" ***\n",
          "Version and date of tested module \"linear_algebra\": ",
          linear_algebra_version," ",linear_algebra_date);

/* Generates a system of linear equations by multiplying a generated matrix
   with a generated column vector, then solves the linear systems and compares
   the components of the solution with the components of the vector used to
   generate the solution. The maximal error should be less than 1.5e-13.
   This script can be used for a rudimentary benchmarking:

   Solving the system takes about 7 seconds on a 
    AMD K6 II 350 Mhz, 64MByte RAM, Linux System with esl running on
    top of scm scheme (Version 5c3).
   Same configuration, but guile (version 1.3) instead of scm takes about 
   37 seconds.
   Same configuration, but elk (version unknown, seems to be from about 1994),
   instead of scm takes about 20 seconds.
   
*/
with maxerror::0,a::0,b::0,c::0,x::0 do

***displayln("beginning"),
a:[1..100,1..100],
b:zerocol(100),
***displayln("matrices a,b generated"),
for i from 1 to 100 do 
  for j from 1 to 100 do
    a[i,j] := i+1/j
  endfor,
  a[i,i] := a[i,i]+10000
endfor,
for i from 1 to 100 do b[i,1] := i+1/(200-i) endfor,
***displayln("matrices a,b initialized"),
c:matmul(a,b),
***displayln("Matrix a is"),
***matdisplay(a),
***displayln("Column b is"),
***matdisplay(b),
displayln("Column c is now"),
matdisplay(c),
displayln("Solving linear equation"),
x:lineqsolve(a,c),
for i from 1 to 100 do 
  maxerror:max(maxerror,abs(b[i,1]-x[i,1])),
  displayln(b[i,1],"  ",x[i,1],"  ",b[i,1]-x[i,1]) 
endfor,
displayln("Maximal error of components of the solution is ",maxerror)
endwith;

displayln("\nModule \"test_linear_algebra\" (Version ",
       test_linear_algebra_version,", ",test_linear_algebra_date,")");
